--PJ017930- Change 01 -  07012015

USE [COWS]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

--DROP TABLE [dbo].[SIPT_EVENT_ACTY]
--DROP TABLE [dbo].[SIPT_RELTD_ORDR]
--DROP TABLE [dbo].[SIPT_EVENT]
--DROP TABLE [dbo].[LK_SIPT_ACTY_TYPE]

-- Table LK_SIPT_ACTY_TYPE to store the lookup data for the SIPT Activity Type section in SIPT_EVENT table

CREATE TABLE [dbo].[LK_SIPT_ACTY_TYPE]
( 
	[SIPT_ACTY_TYPE_ID]      smallint  		NOT NULL ,
	[SIPT_ACTY_TYPE_DES]     varchar(100)  	NOT NULL ,
	[REC_STUS_ID] 		tinyint 		NOT NULL CONSTRAINT [DF_RECSTUSID_LK_SIPT_ACTY_TYPE_1] DEFAULT ((1)),
	[CREAT_BY_USER_ID] [int] NOT NULL,
	[MODFD_BY_USER_ID] [int] NULL,
	[CREAT_DT]          smalldatetime  	NOT NULL CONSTRAINT [DF_getdate_LK_SIPT_ACTY_TYPE_1] DEFAULT  getdate(),
	[MODFD_DT]			smalldatetime 	NULL,
	CONSTRAINT [PK_LK_SIPT_ACTY_TYPE] PRIMARY KEY  CLUSTERED ([SIPT_ACTY_TYPE_ID] ASC)
	WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
go

ALTER TABLE [dbo].[LK_SIPT_ACTY_TYPE]  WITH NOCHECK ADD  CONSTRAINT [FK01_LK_SIPT_ACTY_TYPE] FOREIGN KEY([REC_STUS_ID])
REFERENCES [dbo].[LK_REC_STUS] ([REC_STUS_ID])
GO

ALTER TABLE [dbo].[LK_SIPT_ACTY_TYPE] CHECK CONSTRAINT [FK01_LK_SIPT_ACTY_TYPE]
GO

ALTER TABLE [dbo].[LK_SIPT_ACTY_TYPE]  WITH NOCHECK ADD  CONSTRAINT [FK02_LK_SIPT_ACTY_TYPE] FOREIGN KEY([MODFD_BY_USER_ID])
REFERENCES [dbo].[LK_USER] ([USER_ID])
GO

ALTER TABLE [dbo].[LK_SIPT_ACTY_TYPE] CHECK CONSTRAINT [FK02_LK_SIPT_ACTY_TYPE]
GO

ALTER TABLE [dbo].[LK_SIPT_ACTY_TYPE]  WITH NOCHECK ADD  CONSTRAINT [FK03_LK_SIPT_ACTY_TYPE] FOREIGN KEY([CREAT_BY_USER_ID])
REFERENCES [dbo].[LK_USER] ([USER_ID])
GO

ALTER TABLE [dbo].[LK_SIPT_ACTY_TYPE] CHECK CONSTRAINT [FK03_LK_SIPT_ACTY_TYPE]
GO

-- Table LK_SIPT_PROD_TYPE to store the lookup data for SIPT product type section in SIPT_EVENT table
CREATE TABLE [dbo].[LK_SIPT_PROD_TYPE]
( 
	[SIPT_PROD_TYPE_ID]      smallint  		NOT NULL ,
	[SIPT_PROD_TYPE_DES]     varchar(100)  	NOT NULL ,
	[REC_STUS_ID] 		tinyint 		NOT NULL CONSTRAINT [DF_RECSTUSID_LK_SIPT_PROD_TYPE_1] DEFAULT ((1)),
	[CREAT_DT]          smalldatetime  	NOT NULL CONSTRAINT [DF_getdate_LK_SIPT_PROD_TYPE_1] DEFAULT  getdate(),
	CONSTRAINT [PK_LK_SIPT_PROD_TYPE] PRIMARY KEY  CLUSTERED ([SIPT_PROD_TYPE_ID] ASC)
	WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
go

ALTER TABLE [dbo].[LK_SIPT_PROD_TYPE]  WITH NOCHECK ADD  CONSTRAINT [FK01_LK_SIPT_PROD_TYPE] FOREIGN KEY([REC_STUS_ID])
REFERENCES [dbo].[LK_REC_STUS] ([REC_STUS_ID])
GO

ALTER TABLE [dbo].[LK_SIPT_PROD_TYPE] CHECK CONSTRAINT [FK01_LK_SIPT_PROD_TYPE]
GO

-- Table LK_SIPT_TOLL_TYPE to store the lookup data for SIPT Toll type section in SIPT_EVENT table
CREATE TABLE [dbo].[LK_SIPT_TOLL_TYPE]
( 
	[SIPT_TOLL_TYPE_ID]      tinyint  		NOT NULL ,
	[SIPT_TOLL_TYPE_DES]     varchar(100)  	NOT NULL ,
	[REC_STUS_ID] 		tinyint 		NOT NULL CONSTRAINT [DF_RECSTUSID_LK_SIPT_TOLL_TYPE_1] DEFAULT ((1)),
	[CREAT_DT]          smalldatetime  	NOT NULL CONSTRAINT [DF_getdate_LK_SIPT_TOLL_TYPE_1] DEFAULT  getdate(),
	CONSTRAINT [PK_LK_SIPT_TOLL_TYPE] PRIMARY KEY  CLUSTERED ([SIPT_TOLL_TYPE_ID] ASC)
	WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
go

ALTER TABLE [dbo].[LK_SIPT_TOLL_TYPE]  WITH NOCHECK ADD  CONSTRAINT [FK01_LK_SIPT_TOLL_TYPE] FOREIGN KEY([REC_STUS_ID])
REFERENCES [dbo].[LK_REC_STUS] ([REC_STUS_ID])
GO

ALTER TABLE [dbo].[LK_SIPT_TOLL_TYPE] CHECK CONSTRAINT [FK01_LK_SIPT_TOLL_TYPE]
GO


-- Table SIPT_EVENT_ACTY to store the mapping between SIPT event and LK_SIPT_ACTY_TYPE from the SIPT event UI
CREATE TABLE [dbo].[SIPT_EVENT_ACTY]
(
	[EVENT_ID] [int] NOT NULL,
	[SIPT_ACTY_TYPE_ID] [smallint] NOT NULL,
	[CREAT_DT] [datetime] NOT NULL CONSTRAINT [DF_getdate_SIPT_EVENT_ACTY_1]  DEFAULT (getdate()),
 CONSTRAINT [PK_SIPT_EVENT_ACTY] PRIMARY KEY CLUSTERED 
(
	[EVENT_ID] ASC,
	[SIPT_ACTY_TYPE_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[SIPT_EVENT_ACTY]
	ADD CONSTRAINT [FK01_SIPT_EVENT_ACTY] FOREIGN KEY ([EVENT_ID]) REFERENCES [dbo].[EVENT]([EVENT_ID])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go

ALTER TABLE [dbo].[SIPT_EVENT_ACTY]
	ADD CONSTRAINT [FK02_SIPT_EVENT_ACTY] FOREIGN KEY ([SIPT_ACTY_TYPE_ID]) REFERENCES [dbo].[LK_SIPT_ACTY_TYPE]([SIPT_ACTY_TYPE_ID])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go

-- Table SIPT_EVENT_TOLL_TYPE to store the mapping between SIPT event and LK_SIPT_TOLL_TYPE from the SIPT event UI
CREATE TABLE [dbo].[SIPT_EVENT_TOLL_TYPE]
(
	[EVENT_ID] [int] NOT NULL,
	[SIPT_TOLL_TYPE_ID] [tinyint] NOT NULL,
	[CREAT_DT] [datetime] NOT NULL CONSTRAINT [DF_getdate_SIPT_EVENT_TOLL_TYPE_1]  DEFAULT (getdate()),
 CONSTRAINT [PK_SIPT_EVENT_TOLL_TYPE] PRIMARY KEY CLUSTERED 
(
	[EVENT_ID] ASC,
	[SIPT_TOLL_TYPE_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[SIPT_EVENT_TOLL_TYPE]
	ADD CONSTRAINT [FK01_SIPT_EVENT_TOLL_TYPE] FOREIGN KEY ([EVENT_ID]) REFERENCES [dbo].[EVENT]([EVENT_ID])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go

ALTER TABLE [dbo].[SIPT_EVENT_TOLL_TYPE]
	ADD CONSTRAINT [FK02_SIPT_EVENT_TOLL_TYPE] FOREIGN KEY ([SIPT_TOLL_TYPE_ID]) REFERENCES [dbo].[LK_SIPT_TOLL_TYPE]([SIPT_TOLL_TYPE_ID])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go

-- Table EVENT_DOC to store the documents uploaded from SIPT Event UI
--CREATE TABLE [dbo].[EVENT_DOC]
--(
--	[EVENT_DOC_ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
--	[EVENT_ID] [int] NOT NULL,
--	[FILE_NME] [varchar](255) NOT NULL,
--	[FILE_CNTNT] [varbinary](max) NOT NULL,
--	[FILE_SIZE_QTY] [int] NOT NULL,
--	[CMNT_TXT] [varchar](1000) NULL,
--	[CREAT_DT] [datetime] NOT NULL CONSTRAINT [DF_getdate_EVENT_DOC_1]  DEFAULT (getdate()),
--	[MODFD_DT] [datetime] NULL,
--	[CREAT_BY_USER_ID] [int] NOT NULL,
--	[MODFD_BY_USER_ID] [int] NULL,
--	[REC_STUS_ID] [tinyint] NOT NULL CONSTRAINT [DF_RECSTUSID_EVENT_DOC_1]  DEFAULT ((1)),
-- CONSTRAINT [PK_EVENT_DOC] PRIMARY KEY CLUSTERED 
--(
--	[EVENT_DOC_ID] ASC
--)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
--) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

--GO

--ALTER TABLE [dbo].[EVENT_DOC]
--	ADD CONSTRAINT [FK01_EVENT_DOC] FOREIGN KEY ([EVENT_ID]) REFERENCES [dbo].[EVENT]([EVENT_ID])
--		ON DELETE NO ACTION
--		ON UPDATE NO ACTION
--go

--ALTER TABLE [dbo].[EVENT_DOC]
--	ADD CONSTRAINT [FK02_EVENT_DOC] FOREIGN KEY ([CREAT_BY_USER_ID]) REFERENCES [dbo].[LK_USER]([USER_ID])
--		ON DELETE NO ACTION
--		ON UPDATE NO ACTION
--go

--ALTER TABLE [dbo].[EVENT_DOC]
--	ADD CONSTRAINT [FK03_EVENT_DOC] FOREIGN KEY ([MODFD_BY_USER_ID]) REFERENCES [dbo].[LK_USER]([USER_ID])
--		ON DELETE NO ACTION
--		ON UPDATE NO ACTION
--go

--ALTER TABLE [dbo].[EVENT_DOC]  WITH NOCHECK ADD  CONSTRAINT [FK04_EVENT_DOC] FOREIGN KEY([REC_STUS_ID])
--REFERENCES [dbo].[LK_REC_STUS] ([REC_STUS_ID])
--GO

--ALTER TABLE [dbo].[EVENT_DOC] CHECK CONSTRAINT [FK04_EVENT_DOC]
--GO

CREATE TABLE [dbo].[SIPT_RELTD_ORDR]
(
	[SIPT_RELTD_ORDR_ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[EVENT_ID]			 [int] NOT NULL,	 
	[M5_ORDR_NBR]			   varchar(50) 	NOT NULL ,
	[CREAT_DT] [datetime] NOT NULL CONSTRAINT [DF_getdate_SIPT_RELTD_ORDR_1]  DEFAULT (getdate()),
 CONSTRAINT [PK_SIPT_RELTD_ORDR] PRIMARY KEY CLUSTERED 
(
	[SIPT_RELTD_ORDR_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY],
CONSTRAINT [UX01_SIPT_RELTD_ORDR] UNIQUE NONCLUSTERED ([M5_ORDR_NBR] ASC, [EVENT_ID] ASC)
	WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[SIPT_RELTD_ORDR]
	ADD CONSTRAINT [FK01_SIPT_RELTD_ORDR] FOREIGN KEY ([EVENT_ID]) REFERENCES [dbo].[EVENT]([EVENT_ID])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go


-- Table SIPT_EVENT to store the data for SIPT Event from the UI

CREATE TABLE [dbo].[SIPT_EVENT]
( 
	[EVENT_ID] 					int  			NOT NULL,
	[EVENT_TITLE_TXT] 			[varbinary](max) NOT NULL,
	[M5_ORDR_NBR]				varchar(50) 	NOT NULL ,
	[H1] [dbo].[H1] NULL,
	[SITE_ID] varchar(50) NOT NULL,
	[H6] [dbo].[H6] NOT NULL,
	[CUST_NME] 	varbinary(max)  NULL,
	[CHARS_ID] VARCHAR(9) NULL,
	[TEAM_PDL_NME] [varchar](255) NULL,
	[SIPT_PROD_TYPE_ID] smallint NOT NULL,
	[SIPT_DOC_LOC_TXT] [varchar](max) NULL,
	[SITE_CNTCT_NME] [varbinary](max) NULL,
	[SITE_CNTCT_PHN_NBR] [varbinary](max) NULL,
	[SITE_CNTCT_HR_NME] [varbinary](max) NULL,
	[SITE_CNTCT_EMAIL_ADR] [varbinary](max) NULL,
	[CUST_REQ_ST_DT] [smalldatetime] NULL,
	[CUST_REQ_END_DT] [smalldatetime] NULL,
	[PRJ_ID] VARCHAR(20) NULL,
	[FOC_DT] [date] NULL,
	[WRK_DES]	VARCHAR(MAX)	NULL,
	[REQOR_USER_ID] [int] NULL,
	[NTWK_ENGR_ID] [int] NULL,
	[NTWK_TECH_ENGR_ID] [int] NULL,
	[PM_ID] [int] NULL,
	[US_INTL_CD] [CHAR](1) NULL,
	[SITE_ADR] [varbinary](max) NULL,
	[FLR_BLDG_NME] [varbinary](max) NULL,
	[CTY_NME] [varbinary](max) NULL,
	[STT_PRVN_NME] [varbinary](max) NULL,
	[CTRY_RGN_NME] [varbinary](max) NULL,
	[ZIP_CD] [varbinary](max) NULL,
	[SIPT_DESGN_DOC] [varchar](max) NULL,
	[EVENT_STUS_ID]   			tinyint  		NOT NULL ,
	[WRKFLW_STUS_ID]   			tinyint  		NOT NULL ,
	[CREAT_BY_USER_ID] [int] NOT NULL,
	[MODFD_BY_USER_ID] [int] NULL,
	[MODFD_DT] [datetime] NULL,
	[CREAT_DT] [datetime] NOT NULL CONSTRAINT [DF_getdate_SIPT_EVENT_1]  DEFAULT (getdate()),
	[REC_STUS_ID] [tinyint] NOT NULL CONSTRAINT [DF_RECSTUSID_SIPT_EVENT_1]  DEFAULT ((1)),
	CONSTRAINT [PK_SIPT_EVENT] PRIMARY KEY  CLUSTERED ([EVENT_ID] ASC)
	WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]  TEXTIMAGE_ON [PRIMARY]
go

CREATE NONCLUSTERED INDEX [IDX_SIPT_EVENT_01] ON [dbo].[SIPT_EVENT]
( 
	[M5_ORDR_NBR]    ASC
)
go

ALTER TABLE [dbo].[SIPT_EVENT]  ADD  CONSTRAINT [FK01_SIPT_EVENT] FOREIGN KEY([EVENT_ID])
REFERENCES [dbo].[EVENT] ([EVENT_ID])
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
GO

ALTER TABLE [dbo].[SIPT_EVENT] ADD  CONSTRAINT [FK02_SIPT_EVENT] FOREIGN KEY([EVENT_STUS_ID])
REFERENCES [dbo].[LK_EVENT_STUS] ([EVENT_STUS_ID])
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
GO

ALTER TABLE [dbo].[SIPT_EVENT]  ADD  CONSTRAINT [FK03_SIPT_EVENT] FOREIGN KEY([WRKFLW_STUS_ID])
REFERENCES [dbo].[LK_WRKFLW_STUS] ([WRKFLW_STUS_ID])
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
GO

ALTER TABLE [dbo].[SIPT_EVENT]
	ADD CONSTRAINT [FK04_SIPT_EVENT] FOREIGN KEY ([CREAT_BY_USER_ID]) REFERENCES [dbo].[LK_USER]([USER_ID])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go

ALTER TABLE [dbo].[SIPT_EVENT]
	ADD CONSTRAINT [FK05_SIPT_EVENT] FOREIGN KEY ([MODFD_BY_USER_ID]) REFERENCES [dbo].[LK_USER]([USER_ID])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go

ALTER TABLE [dbo].[SIPT_EVENT]
	ADD CONSTRAINT [FK06_SIPT_EVENT] FOREIGN KEY ([NTWK_ENGR_ID]) REFERENCES [dbo].[LK_USER]([USER_ID])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go

ALTER TABLE [dbo].[SIPT_EVENT]
	ADD CONSTRAINT [FK07_SIPT_EVENT] FOREIGN KEY ([NTWK_TECH_ENGR_ID]) REFERENCES [dbo].[LK_USER]([USER_ID])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go

ALTER TABLE [dbo].[SIPT_EVENT]
	ADD CONSTRAINT [FK08_SIPT_EVENT] FOREIGN KEY ([PM_ID]) REFERENCES [dbo].[LK_USER]([USER_ID])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go

ALTER TABLE [dbo].[SIPT_EVENT]
	ADD CONSTRAINT [FK09_SIPT_EVENT] FOREIGN KEY ([REC_STUS_ID]) REFERENCES [dbo].[LK_REC_STUS]([REC_STUS_ID])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go

ALTER TABLE [dbo].[SIPT_EVENT]
	ADD CONSTRAINT [FK10_SIPT_EVENT] FOREIGN KEY ([SIPT_PROD_TYPE_ID]) REFERENCES [dbo].[LK_SIPT_PROD_TYPE]([SIPT_PROD_TYPE_ID])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go

/*
ALTER TABLE dbo.SIPT_EVENT
ADD [US_INTL_CD] [CHAR](1) NULL,
	[SITE_ADR] [varbinary](max) NULL,
	[FLR_BLDG_NME] [varbinary](max) NULL,
	[CTY_NME] [varbinary](max) NULL,
	[STT_PRVN_NME] [varbinary](max) NULL,
	[CTRY_RGN_NME] [varbinary](max) NULL,
	[ZIP_CD] [varbinary](max) NULL


UPDATE SIPT_EVENT SET [US_INTL_CD] = 'D'
*/

--
SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO